;CAD Ideas layer configure save and restore program
;The layer Configure program consist of 8 lisp routines
;these 8 routines may not be altered or used separately
;without written permission of Ed Azoyan
;Copyright (C) 07/07/89 by Ed Azoyan and CAD IDEAS, Inc. All Rights Reserved
;Version 2.2
;With prompts
;added ability to restore layer configurations 
;without restoring a view 12/13/89
;added ability to delete layer configurations 12/16/89
;added pick from screen menu to restor layer config 12/16/89
;added enviorment setting 02/02/90
;;;;;
;;;;;	For comments or sugestions or if you would like me to alter this
;;;;;	program for you please call me.  Thanks,  ED Azoyan
;;;;;		
;;;;;		voice (602) 996-4469
;;;;;		FAX   (602) 996-5878
;;;;;		
;;;;;
;;;;;
(vmon)
(prompt "\nInitial Loading CAD IDEAS, inc. Lisp Routine..... Please Stand By...... ")
(prompt "\nCopyright (C) 07/10/89 by Ed Azoyan and CAD IDEAS, inc. ")
;;;;;;;;;;;;;;;;;;;;;;;;;; defun lcerr is a error handeler
;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun lcerr (msg)
	(if (/= msg "Function cancelled")
		(princ (strcat "\nError: " msg))
	)
	(grtext)
	(cond(rcf (close rcf)))
	(cond(rvf (close rvf)))
	(cond(rvnf (close rvnf)))
	(cond(lcf (close lcf)))
	(cond(vnf (close vnf)))
	(cond(f1 (close f1)))
	(cond(f2 (close f2)))
	(setvar "LIMCHECK" lmc)
	(setvar "EXPERT" exp)
	(setvar "BLIPMODE" blpm)
	(setvar "CMDECHO" cmeo)
	(setq *error* exerr)
	(prin1)
)
;;;;;;;;;;;;;;;;;;;;;;; defun ckfl is a function for creating two files
;;;;;;;;;;;;;;;;;;;;;;; 	that are created by the SVLR command
;;;;;;;;;;;;;;;;;;;;;;; 	the files are  xxxxxxxx.vfg  view name file
;;;;;;;;;;;;;;;;;;;;;;; 	and  xxxxxxxx.lfg  layer config. file
;;;;;;;;;;;;;;;;;;;;;;; 	where "xxxxxxxx" depends on the envir. setting
;;;;;;;;;;;;;;;;;;;;;;;
(defun ckfl (/ f1 f2 env1 rvnf tvnm tvls f2r f1e)
	(prompt (strcat "\nWriting " (strcat envr ".tfg") " Temporary Layer Confg. file... \nPlease Stand by......"))
	(setq f1 (open (strcat envr ".tfg") "w")
		f2 (open (strcat envr ".lfg") "r")
	)
	(prompt (strcat "\nReading " (strcat envr ".lfg") " Layer Confg. file... \nPlease Stand by......"))
	(setq env1 (read-line f2))
	(while env1
		(if (/= env1 (strcat "V$!" vnm))
			(progn
				(while (and env1(/= env1 (strcat "V$!" vnm)))
					(prompt "\nWriting..")
					(write-line env1 f1)
					(prompt "\nReading..")
					(setq env1 (read-line f2))
				)
			)
			(progn
				(cond ((equal vna "O")
					(prompt "\nWriting.. ")
					(write-line env1 f1)
					(write-line cln f1)
					(write-line a1 f1)
					(write-line a3 f1)
					(write-line b1 f1)
					(write-line b3 f1)
					(prompt "\nReading.. ")
				      )
				)
				(setq env1 (read-line f2)) 
				(while (and env1 (/= (substr env1 1 3) "V$!"))
					(setq env1 (read-line f2))
				)
			)
		)
	)
	(close f1)
	(close f2)
	(cond ((equal vna "D")
		(setq rvnf (open (strcat envr ".vfg") "r"))
		(setq tvnm (read-line rvnf)
			tvls (list tvnm)
		)
		(while tvnm
			(setq tvnm (read-line rvnf))
			(cond (tvnm (setq tvls (cons tvnm tvls))))
		)
		(close rvnf)
		(setq tvls (reverse tvls)
			rvnf (open (strcat envr ".vfg") "w")
		)
		(while tvls
			(if (/= (car tvls) vnm)
				(progn
					(write-line (car tvls) rvnf)
					(setq tvls (cdr tvls))
				)
				(setq tvls (cdr tvls))
			)
		)
		(close rvnf)
		(cond ((tblsearch "VIEW" vnm) (command "VIEW" "D" vnm)))
	      )
	)
	(prompt "\n")
	(setq f2r (strcat "COPY " envr ".tfg " envr ".lfg")
		f1e (strcat "ERASE " envr ".tfg")
	)
	(prompt "\nCopying Tempory Config. file to new Config. file.. ")
	(command "SH" f2r)
	(prompt "\nErasing Tempory Config. file.. ")
	(command "SH" f1e)
	(setq rvnf (open (strcat envr ".vfg") "r"))
	(cond ((null (read-line rvnf)) (command "SH" (strcat "ERASE " envr ".vfg"))))
	(close rvnf)
	(cond ((equal vna "O")
		(prompt "\nNew Layer Configuration Saved... ")
	      )
	      ((equal vna "D")
	      	(prompt "\nLayer Configuration deleted... ")
	      )
	)
	(graphscr)
)
;;;;;;;;;;;;;;;;; defun ritf is a function for putting layer names in the
;;;;;;;;;;;;;;;;; 	screen menu area
;;;;;;;;;;;;;;;;;
(defun ritf (a b / a1 a2 a3 b1 b2 b3 rvnf evn vnf vna lcf)
	(setq a1 (car a)		
		a2 (cdr a)
		a3 ""
		b1 (car b)
		b2 (cdr b)
		b3 ""
	)
	(repeat (length a2)
		(if (> (length a2) 1)
			(progn
				(setq a3 (strcat a3 (car a2) ",")
					a2 (cdr a2)
				)
			)
			(setq a3 (strcat a3 (car a2)))
		)
	)
	(repeat (length b2)
		(if (> (length b2) 1)
			(progn
				(setq b3 (strcat b3 (car b2) ",")
					b2 (cdr b2)
				)
			)
			(setq b3 (strcat b3 (car b2)))
		)
	)
	(setq rvnf (open (strcat envr ".vfg") "r"))
	(cond (rvnf
		(prompt (strcat "\nReading " (strcat envr ".vfg") " Confg. View Name file... \nPlease Stand by......"))
		(setq evn (read-line rvnf))
		(while (and evn (/= evn vnm))
			(setq evn (read-line rvnf))
		)
		(close rvnf)
		(prompt "\n")
	      )
	)
	(if (equal evn vnm)
		(progn
			(setq vna(substr(strcase(getstring "\nThis Named Config. exists... (D)elete it, (O)verwrite it, or (N)othing?  <N>: "))1 1))	
			(if (or (equal vna "O")(equal vna "D"))
				(setq vna vna)
				(setq vna "N")
			)
			(if (or (equal vna "O")(equal vna "D"))
				(ckfl)
				(prompt "\nRun the command again... and Use another Name.. ")
			)
		)
		(progn
			(prompt (strcat "\nWriting to " (strcat envr ".vfg") " Confg. View Name file... \nPlease Stand by......"))
			(setq vnf (open (strcat envr ".vfg") "a"))
			(write-line vnm vnf)
			(close vnf)
			(prompt "\n")
			(prompt (strcat "\nWriting to " (strcat envr ".lfg") " Layer Confg. file... \nPlease Stand by......"))
			(setq lcf (open (strcat envr ".lfg") "a"))
			(write-line (strcat "V$!" vnm) lcf)
			(write-line cln lcf)
			(write-line a1 lcf)
			(write-line a3 lcf)
			(write-line b1 lcf)
			(write-line b3 lcf)
			(close lcf)
			(prompt "\nNew Layer View Saved.. ")
		)
	)
)			
;;;;;;;;;;;;;;;;;;;;; defun lsts is a function for creating a list of names
;;;;;;;;;;;;;;;;;;;;; 	to be used by the ritf function
;;;;;;;;;;;;;;;;;;;;;
(defun lsts (/ b c e f g i)
	(setq cln (getvar "CLAYER")
		b (list "OFF")
		c (list "FREEZE")
	)
	(setq e (tblnext "LAYER" T))
	(while e
		(setq f (cdr(assoc 2 e))
			g (cdr(assoc 62 e))
			i (cdr(assoc 70 e))
		)
		(cond ((minusp g)
			(setq b (cons f b)
			)
		      )
		)
		(cond ((or (= i 1) (= i 65))
			(setq c (cons f c)
			)
		      )
		)
		(setq e (tblnext "LAYER"))
	)
	(setq b1 (reverse b)
		c1 (reverse c)
	)
	(ritf b1 c1)
)
;;;;;;;;;;;;;;;;;;;;;;; defun envi is a function for setting the LRCONFIG
;;;;;;;;;;;;;;;;;;;;;;; 	enviorment only works for release 10 or better
;;;;;;;;;;;;;;;;;;;;;;;
(defun envi (/ po1 po2)
	(cond ((and (= (strlen envr) 2) (= (strcase (substr envr 1 2)) "N;"))
		(setq envr "LRCONFIG")
	      )
	      ((and (> (strlen envr) 2) (= (strcase (substr envr 1 2)) "N;"))
	      	(if (= (substr envr (strlen envr)) "\\")
	      		(setq envr (strcat (substr envr 3) "LRCONFIG"))
	      		(setq envr (strcat (substr envr 3) "\\" "LRCONFIG"))
	      	)
	      )
	      ((and (>= (strlen envr) 2) (/= (strcase (substr envr 1 1)) ";") (/= (strcase (substr envr 2 1)) ";"))
	      	(setq po1 1
	      		po2 0
	      	)
	      	(while (<= po1 (strlen (getvar "DWGNAME")))
	      		(if (or (= (substr (getvar "DWGNAME") po1 1) "\\")(= (substr (getvar "DWGNAME") po1 1) "/"))
	      			(progn
		      			(setq po2 po1
		      				po1 (1+ po1)
		      			)
	      			)
	      			(setq po1 (1+ po1))
	      		)
	      	)
	      	(if (= (substr envr (strlen envr)) "\\")
	      		(setq envr (strcat envr (substr (getvar "DWGNAME") (1+ po2))))
	      		(setq envr (strcat envr "\\" (substr (getvar "DWGNAME") (1+ po2))))
	      	)
	      )
	      (t (setq envr (getvar "DWGNAME")))
	)
)
;;;;;;;;;;;;;;;;;;;;;;; defun C:SVLR is the new save layer config command
;;;;;;;;;;;;;;;;;;;;;;;
(defun C:SVLR (/ exerr envr blpm cmeo lmc exp vnm vnm1 va)
	(setq exerr *error*
		*error* lcerr
		blpm (getvar "BLIPMODE")
		cmeo (getvar "CMDECHO")
		lmc (getvar "LIMCHECK")
		exp (getvar "EXPERT")
	)
	(if getenv (setq envr (getenv "LRCONFIG")))
	(setvar "BLIPMODE" 0)
	(setvar "CMDECHO" 0)
	(setvar "LIMCHECK" 0)
	(setvar "EXPERT" 4)
	(if envr
		(envi)
		(setq envr (getvar "DWGNAME"))
	)
	(setq vnm (strcase (getstring "\nType in an Existing view name.... ")))
	(prompt "\nSearching drawing for View name... ")
	(setq vnm1 (tblsearch "VIEW" vnm))
	(if vnm1
		(progn
			(prompt "\nView Name Found.. ")
			(lsts)
		)
		(progn
			(prompt (strcat "\n< " vnm " > is not the name of an Existing View in this Drawing... "))
			(setq va (substr(strcase(getstring "\nCreate it?... (C)urrent display, define (W)indow, or (N)o view  <N>: "))1 1))
			(if (and (/= (substr vnm 1 1) "")(/= (substr vnm 1 1) " ")(or (equal va "C")(equal va "W")))
				(progn
					(if (equal va "W")
						(progn
							(setvar "CMDECHO" 1)
							(command "VIEW" "W" vnm pause pause)
							(setvar "CMDECHO"0)
						)
						(progn
							(prompt "\nCreating new View.. ")
							(command "VIEW" "S" vnm)
							(prompt "\nView has been Created.. ")
						)
					)
					(lsts)
				)
				(progn
					(if (and (/= (substr vnm 1 1) "")(/= (substr vnm 1 1) " "))
						(lsts)
						(prompt"\nInvalid name for Configuration... ")
					)
				)
			)
		)
	)
	(setvar "LIMCHECK" lmc)
	(setvar "EXPERT" exp)
	(setvar "BLIPMODE" blpm)
	(setvar "CMDECHO" cmeo)
	(setq *error* exerr)
	(prin1)
)
;;;;;;;;;;;;;;;;;;;;; defun gvnm is a function for putting layer config. names
;;;;;;;;;;;;;;;;;;;;; 	in the screen menu area for selection
;;;;;;;;;;;;;;;;;;;;;
(defun gvnm (/ rvf mn evn1 vnls lp mns)
	(setq rvf (open (strcat envr ".vfg") "r"))
	(if rvf
		(progn
			(setq mn 2)
			(grtext 1 "CFGNAMES")
			(repeat 19
				(grtext mn " ")
				(setq mn (1+ mn))
			)
			(setq mn 2
				evn1 (read-line rvf)
				vnls (list "" "")
			)
			(prompt (strcat "\nReading " (strcat envr ".vfg") " Confg. View Name file... \nPlease Stand by......"))
			(while evn1
				(grtext mn evn1)
				(setq vnls (cons evn1 vnls))
				(if (< mn 20)
					(progn
						(setq mn (1+ mn)
							evn1 (read-line rvf)
						)
					)
					(progn
						(cond ((setq evn1 (read-line rvf))
							(setq lp T
								vnls (reverse vnls)
							)
							(prompt "\nSelect Config. from Screen menu or Return for more. ")
						       )
						)
						(while lp
							(setq mns (grread))
							(if (and (= (car mns)4)
								(>= (cadr mns)2)
								(<= (cadr mns)20)
								)
								(progn
									(setq lp ()
										evn1 ()
									)
								)
								(progn
									(if (or (and (= (car mns) 6)
											(= (cadr mns) 0)
										)
										(and (= (car mns) 2)
											(or(= (cadr mns)13)
												(= (cadr mns)32)
											)
										)
									     )
									     	(progn
											(prompt (strcat "\nReading " (strcat envr ".vfg") " Confg. View Name file... \nPlease Stand by......"))
											(setq mn 2)
											(repeat 19
												(grtext mn " ")
												(setq mn (1+ mn))
											)
											(setq mn 2
												vnls (list "" "")
												mns ()
												lp ()
											)
									     	)
									     	(prompt"\nNot a valid Selection or Entry, Tyr again.. ")
									)
								)
							)
						)
					)	
				)
			)
			(if (null mns)
				(progn
					(close rvf)
					(setq lp T
						vnls (reverse vnls)
					)
					(prompt "\nSelect Config. from Screen menu. ")
					(while lp
						(setq mns (grread))
						(if (and (= (car mns)4)
							(>= (cadr mns)2)
							(<= (cadr mns) (1- (length vnls)))
							)
							(progn
								(grtext)
								(setq lp ())
								(nth (cadr mns) vnls)
							)
							(prompt"\nNot a valid Selection Try again.. ")
						)
					)
				)
				(progn
					(grtext)
					(nth (cadr mns) vnls)
				)
			)
		)
		()
	)
)
;;;;;;;;;;;;;;;;;;;;;; defun C:RSLR is the new restore layer config. command
;;;;;;;;;;;;;;;;;;;;;;
(defun C:RSLR (/ exerr envr blpm cmeo lmc exp vnm vnm2 rcf rvf evn1 evn cln a1 a3 b1 b3 )
	(setq exerr *error*
		*error* lcerr
		blpm (getvar "BLIPMODE")
		cmeo (getvar "CMDECHO")
		lmc (getvar "LIMCHECK")
		exp (getvar "EXPERT")
	)
	(if getenv (setq envr (getenv "LRCONFIG")))
	(setvar "BLIPMODE" 0)
	(setvar "CMDECHO" 0)
	(setvar "LIMCHECK" 0)
	(setvar "EXPERT" 4)
	(if envr
		(envi)
		(setq envr (getvar "DWGNAME"))
	)
	(setq vnm (strcase(getstring "\nType in Name of Config. View to restore.. or  ?  for list.. <?>: ")))
	(if (equal vnm "")
		(setq vnm "?")
		(setq vnm vnm)
	)
	(if (equal vnm "?")
		(progn
			(if (setq vnm (gvnm))
				(setq vnm vnm)
				(prompt (strcat "\nCouldn't find < " (strcat envr ".vfg") " > view configuration name file... "))
			)
		)
		(setq vnm vnm)
	)
	(if vnm
		(progn
			(setq vnm2 (tblsearch "VIEW" vnm)
				rvf (open (strcat envr ".vfg") "r")
				rcf(open (strcat envr ".lfg") "r")
			)
		)
	)
	(cond (rvf
		(prompt (strcat "\nReading " (strcat envr ".vfg") " Confg. View Name file... \nPlease Stand by......"))
		(setq evn1 (read-line rvf))
		(while (and evn1 (/= evn1 vnm))
			(setq evn1 (read-line rvf))
		)
		(close rvf)
		(prompt "\n")
	      )
	)
	(if rcf
		(progn
			(if (and vnm2 (equal evn1 vnm))
				(progn
					(prompt (strcat "\nReading " (strcat envr ".lfg") " Layer Confg. file... \nPlease Stand by......"))
					(setq evn (read-line rcf))
					(while (and evn (/= evn (strcat "V$!" vnm)))
						(setq evn (read-line rcf))
					)
					(setq cln (read-line rcf)
						a1 (read-line rcf)
						a3 (read-line rcf)
						b1 (read-line rcf)
						b3 (read-line rcf)
					)
					(close rcf)
					(prompt "\n")
					(command "VIEW" "R" vnm)
					(command "LAYER" "THAW" "*" "ON" "*" "S" cln a1 a3 b1 b3 "")
				)
				(progn
					(if (and (null vnm2)(= evn1 vnm))
						(progn
							(prompt (strcat "\n< " vnm " > is not the name of a Defined View in this drawing... "))
							(prompt "\nOnly layer configuration will be restored. ")
							(prompt (strcat "\nReading " (strcat envr ".lfg") " Layer Confg. file... \nPlease Stand by......"))
							(setq evn (read-line rcf))
							(while (and evn (/= evn (strcat "V$!" vnm)))
								(setq evn (read-line rcf))
							)
							(setq cln (read-line rcf)
								a1 (read-line rcf)
								a3 (read-line rcf)
								b1 (read-line rcf)
								b3 (read-line rcf)
							)
							(close rcf)
							(prompt "\n")
							(command "LAYER" "THAW" "*" "ON" "*" "S" cln a1 a3 b1 b3 "")
						)
						(prompt (strcat "\n< " vnm " > is not the name of a Defined layer configuration... "))
					)
				)
			)
		)
		(prompt (strcat "\nCouldn't find < " (strcat envr ".lfg") " > configuration file... "))
	)
	(setvar "LIMCHECK" lmc)
	(setvar "EXPERT" exp)
	(setvar "BLIPMODE" blpm)
	(setvar "CMDECHO" cmeo)
	(setq *error* exerr)
	(prin1)
)
(prompt "\nThe LRCONFIG lisp routine is loaded......")
(prompt "\nThank You for buying CAD IDEAS LRCONFIG lisp routines. Ver. 2.0    ")
(if getenv
	(cond ((null (getenv "LRCONFIG")) (prompt "\nThe LRCONFIG enviorment is not set.. ")))
	(prompt "\nThe  SET LRCONFIG=  enviorment is not available in this version of AutoCAD ... ")
)
(prin1)
